=== modified file 'procurement_auto/scheduler.py'
--- procurement_auto/scheduler.py	2012-04-17 16:15:15 +0000
+++ procurement_auto/scheduler.py	2012-04-18 08:21:27 +0000
@@ -45,8 +45,8 @@
         proc_obj = self.pool.get('procurement.order')
         freq_obj = self.pool.get('stock.frequence')
 
-        start_date = datetime.now()
-        auto_sup_ids = auto_sup_obj.search(cr, uid, [('next_date', '<=', start_date.strftime('%Y-%m-%d'))])
+        start_date = time.strftime('%Y-%m-%d %H:%M:%S')
+        auto_sup_ids = auto_sup_obj.search(cr, uid, [('next_date', '<=', datetime.now())])
         
         created_proc = []
         report = []
@@ -86,7 +86,7 @@
             elif proc.purchase_id:
                 created_doc += "    * %s => %s \n" % (proc.name, proc.purchase_id.name)
                 
-        end_date = datetime.now()
+        end_date = time.strftime('%Y-%m-%d %H:%M:%S')
                 
         summary = '''Here is the procurement scheduling report for Automatic Supplies
 
@@ -95,13 +95,18 @@
         Total Procurements processed: %d
         Procurements with exceptions: %d
         
-        \n %s \n'''% (start_date, end_date, len(created_proc), report_except, len(created_proc) > 0 and created_doc or '')
+        \n %s \n  Exceptions: \n'''% (start_date, end_date, len(created_proc), report_except, len(created_proc) > 0 and created_doc or '')
         
         summary += '\n'.join(report)
+        if batch_id:
+            self.pool.get('procurement.batch.cron').write(cr, uid, batch_id, {'last_run_on': time.strftime('%Y-%m-%d %H:%M:%S')})
+            old_request = request_obj.search(cr, uid, [('batch_id', '=', batch_id), ('name', '=', 'Procurement Processing Report (Automatic supplies).')])
+            request_obj.write(cr, uid, old_request, {'batch_id': False})
         req_id = request_obj.create(cr, uid,
                 {'name': "Procurement Processing Report (Automatic supplies).",
                  'act_from': uid,
                  'act_to': uid,
+                 'batch_id': batch_id,
                  'body': summary,
                 })
         # UF-952 : Requests should be in consistent state

=== modified file 'procurement_cycle/scheduler.py'
--- procurement_cycle/scheduler.py	2012-04-17 16:12:49 +0000
+++ procurement_cycle/scheduler.py	2012-04-18 08:21:27 +0000
@@ -48,9 +48,9 @@
         product_obj = self.pool.get('product.product')
         freq_obj = self.pool.get('stock.frequence')
 
-        start_date = datetime.now()
+        start_date = time.strftime('%Y-%m-%d %H:%M:%S')
         
-        cycle_ids = cycle_obj.search(cr, uid, [('next_date', '<=', start_date.strftime('%Y-%m-%d'))])
+        cycle_ids = cycle_obj.search(cr, uid, [('next_date', '<=', datetime.now())])
         
         created_proc = []
         report = []
@@ -105,7 +105,7 @@
             elif proc.purchase_id:
                 created_doc += "    * %s => %s \n" % (proc.name, proc.purchase_id.name)
                 
-        end_date = datetime.now()
+        end_date = time.strftime('%Y-%m-%d %H:%M:%S')
                 
         summary = '''Here is the procurement scheduling report for Order Cycle
 
@@ -113,12 +113,18 @@
         End Time: %s
         Total Procurements processed: %d
         Procurements with exceptions: %d
-        \n %s \n'''% (start_date, end_date, len(created_proc), report_except, len(created_proc) > 0 and created_doc or '')
+        \n %s \n Exceptions: \n'''% (start_date, end_date, len(created_proc), report_except, len(created_proc) > 0 and created_doc or '')
         summary += '\n'.join(report)
+        if batch_id:
+            self.pool.get('procurement.batch.cron').write(cr, uid, batch_id, {'last_run_on': time.strftime('%Y-%m-%d %H:%M:%S')})
+            old_request = request_obj.search(cr, uid, [('batch_id', '=', batch_id), ('name', '=', 'Procurement Processing Report (Order cycle).')])
+            request_obj.write(cr, uid, old_request, {'batch_id': False})
+        
         req_id = request_obj.create(cr, uid,
                 {'name': "Procurement Processing Report (Order cycle).",
                  'act_from': uid,
                  'act_to': uid,
+                 'batch_id': batch_id,
                  'body': summary,
                 })
         # UF-952 : Requests should be in consistent state

=== modified file 'procurement_report/procurement_batch.py'
--- procurement_report/procurement_batch.py	2012-04-17 16:12:49 +0000
+++ procurement_report/procurement_batch.py	2012-04-18 08:21:27 +0000
@@ -22,17 +22,30 @@
 from osv import osv
 from osv import fields
 
+import time
+
 class procurement_batch_cron(osv.osv):
     _name = 'procurement.batch.cron'
     _inherit = 'ir.cron'
     
     _columns = {
         'name': fields.char(size=64, string='Name'),
-        'type': fields.selection([('standard', 'From orders'), ('rules', 'Replenishment rules')], string='Type', required=True),
-        'request_ids': fields.one2many('res.request', 'batch_id', string='Associated Requests'),
+        'type': fields.selection([('standard', 'POs creation Batch (from orders)'), ('rules', 'POs creation Batch (replenishment rules)')], string='Type', required=True),
+        'request_ids': fields.one2many('res.request', 'batch_id', string='Associated Requests', readonly=True),
         'cron_ids': fields.one2many('ir.cron', 'batch_id', string='Associated Cron tasks'),
+        'last_run_on': fields.datetime('Last run on', readonly=True),
     }
     
+    def open_request_view(self, cr, uid, ids, context=None):
+        view_id = self.pool.get('ir.model.data').get_object_reference(cr, uid, 'procurement_report', 'batch_requests_view')[1]
+        return {'type': 'ir.actions.act_window',
+                'res_model': 'procurement.batch.cron',
+                'res_id': ids[0],
+                'view_id': [view_id],
+                'view_type': 'form',
+                'view_mode': 'form',
+                'target': 'new'}
+    
     def _create_associated_cron(self, cr, uid, batch_id, vals, context=None):
         '''
         Create cron according to type
@@ -44,29 +57,37 @@
                 'interval_number': vals.get('interval_number'),
                 'interval_type': vals.get('interval_type'),
                 'nextcall': vals.get('nextcall'),
+                'numbercall': -1,
                 'batch_id': int(batch_id),
                 'model': 'procurement.order',
                 'args': '(False, %s)' % batch_id}
         
         if vals.get('type') == 'standard':
             # Create a cron task for the standard batch
-            data.update({'function': 'run_scheduler',
-                         'name': vals.get('name', 'Run mrp scheduler')})
+            data.update({'function': 'procure_confirm',
+                         'args': '(False, False, %s)' % batch_id,
+                         'name': '%s - Run mrp scheduler' % vals.get('name', 'Run mrp scheduler')})
             cron_obj.create(cr, uid, data, context=context)
         else:
             # Create a cron for order cycle
             data.update({'function': 'run_automatic_cycle',
-                         'name': vals.get('name', 'Run automatic cycle')})
+                         'name': '%s - Run automatic cycle' % vals.get('name', 'Run automatic cycle')})
             cron_obj.create(cr, uid, data, context=context)
             
             # Create a cron for auto supply
             data.update({'function': 'run_automatic_supply',
-                         'name': vals.get('name', 'Run automatic supply')})
+                         'name': '%s - Run automatic supply' % vals.get('name', 'Run automatic supply')})
             cron_obj.create(cr, uid, data, context=context)
             
             # Create a cron for threshold values
             data.update({'function': 'run_threshold_value',
-                         'name': vals.get('name', 'Run threshold value')})
+                         'name': '%s - Run threshold value' % vals.get('name', 'Run threshold value')})
+            cron_obj.create(cr, uid, data, context=context)
+            
+            # Create a cron for min/max rules
+            data.update({'function': 'procure_orderpoint_confirm',
+                         'args': '(False, False, %s)' % batch_id,
+                         'name': '%s - Run Min/Max rules' % vals.get('name', 'Run Min/Max rules')})
             cron_obj.create(cr, uid, data, context=context)
         
     def create(self, cr, uid, vals, context=None):
@@ -87,6 +108,9 @@
         '''
         cron_obj = self.pool.get('ir.cron')
         
+        if isinstance(ids, (int, long)):
+            ids = [ids]
+        
         for batch in self.browse(cr, uid, ids, context=context):
             if vals.get('type') and vals.get('type') != batch.type:
                 for cron in batch.cron_ids:
@@ -94,13 +118,52 @@
                 self._create_associated_cron(cr, uid, batch.id, vals, context=context)
             else:
                 for cron in batch.cron_ids:
-                    cron_obj.write(cr, uid, vals, context=context)
+                    cron_obj.write(cr, uid, cron.id, vals, context=context)
                     
         return super(procurement_batch_cron, self).write(cr, uid, ids, vals, context=context)
     
 procurement_batch_cron()
 
 
+class procurement_order(osv.osv):
+    _name = 'procurement.order'
+    _inherit = 'procurement.order'
+    
+    def procure_confirm(self, cr, uid, ids=None, use_new_cursor=False, batch_id=False, context=None):
+        if not context:
+            context = {}
+        ctx = context.copy()
+        ctx.update({'batch_id': batch_id})
+        return self._procure_confirm(cr, uid, ids, use_new_cursor, context=ctx)
+    
+    def procure_orderpoint_confirm(self, cr, uid, automatic=False, use_new_cursor=False, \
+                                    batch_id=False, context=None, user_id=False):
+        if not context:
+            context = {}
+        ctx = context.copy()
+        ctx.update({'batch_id': batch_id})
+        return self._procure_orderpoint_confirm(cr, uid, automatic, use_new_cursor, context=ctx, user_id=user_id)
+    
+    def _hook_request_vals(self, cr, uid, *args, **kwargs):
+        '''
+        Add the batch_id in request
+        '''
+        request_obj = self.pool.get('res.request')
+        res = super(procurement_order, self)._hook_request_vals(cr, uid, *args, **kwargs)
+        if 'context' in kwargs:
+            batch_id = kwargs['context'].get('batch_id', False)
+            res.update({'batch_id': batch_id})
+            
+            # Remove the link between batch and old requests
+            if batch_id:
+                self.pool.get('procurement.batch.cron').write(cr, uid, batch_id, {'last_run_on': time.strftime('%Y-%m-%d %H:%M:%S')})
+                old_request = request_obj.search(cr, uid, [('batch_id', '=', batch_id), ('name', '=', res.get('name', 'Procurement Processing Report.'))])
+                request_obj.write(cr, uid, old_request, {'batch_id': False})
+        return res
+    
+procurement_order()
+
+
 class ir_cron(osv.osv):
     _name = 'ir.cron'
     _inherit = 'ir.cron'

=== modified file 'procurement_report/procurement_batch_view.xml'
--- procurement_report/procurement_batch_view.xml	2012-04-17 16:12:49 +0000
+++ procurement_report/procurement_batch_view.xml	2012-04-18 08:21:27 +0000
@@ -10,9 +10,11 @@
 				<tree string="POs creation batches configuration">
 					<field name="name" />
 					<field name="type" />
+					<field name="last_run_on" />
 					<field name="interval_number" />
 					<field name="interval_type" />
 					<field name="nextcall" />
+					<button name="open_request_view" type="object" icon="terp-tools" string="View requests" />
 				</tree>
 			</field>
 		</record>
@@ -31,9 +33,63 @@
 					<field name="interval_type" />
 					<field name="nextcall" />
 					<field name="active" />
-				</form>
-			</field>
-		</record>
+					<separator colspan="4" string="Requests" />
+					<field name="last_run_on" />
+					<newline />
+					<field name="request_ids" colspan="4">
+						<tree string="Requests">
+							<field name="create_date" />
+							<field name="name" />
+						</tree>
+						<form string="Request">
+							<group colspan="4" col="6">
+								<separator colspan="6" string="General information" />
+								<field name="name" colspan="4" />
+								<field name="create_date" colspan="2" />
+								<separator colspan="6" string="Description" />
+								<field name="body" colspan="6" nolabel="1" />
+							</group>
+						</form>
+					</field>
+				</form>
+			</field>
+		</record>
+		
+		
+		<record id="batch_requests_view" model="ir.ui.view">
+			<field name="name">procurement.batch.form.view</field>
+			<field name="model">procurement.batch.cron</field>
+			<field name="type">form</field>
+			<field name="priority" eval="99" />
+			<field name="arch" type="xml">
+				<form string="Batch view">
+					<group colspan="4" col="6">
+						<separator colspan="6" string="General information" />
+						<field name="name" colspan="4" readonly="1" />
+						<field name="type" readonly="1" />
+						<separator colspan="6" string="Requests" />
+						<field name="last_run_on" />
+						<newline />
+						<field name="request_ids" colspan="6">
+							<tree string="Requests">
+								<field name="create_date" />
+								<field name="name" />
+							</tree>
+							<form string="Request">
+								<group colspan="4" col="6">
+									<separator colspan="6" string="General information" />
+									<field name="name" colspan="4" />
+									<field name="create_date" colspan="2" />
+									<separator colspan="6" string="Description" />
+									<field name="body" colspan="6" nolabel="1" />
+								</group>
+							</form>
+						</field>
+					</group>
+				</form>
+			</field>
+		</record>
+		
 		<record id="action_procurement_batch_form" model="ir.actions.act_window">
 			<field name="name">POs Creation (Batch configuration)</field>
 			<field name="res_model">procurement.batch.cron</field>

=== modified file 'threshold_value/scheduler.py'
--- threshold_value/scheduler.py	2012-04-17 16:15:15 +0000
+++ threshold_value/scheduler.py	2012-04-18 08:21:27 +0000
@@ -53,7 +53,7 @@
         created_proc = []
         report = []
         report_except = 0
-        start_date = datetime.now()
+        start_date = time.strftime('%Y-%m-%d %H:%M:%S')
         
         wf_service = netsvc.LocalService("workflow")
         
@@ -87,7 +87,7 @@
             elif proc.purchase_id:
                 created_doc += "    * %s => %s \n" % (proc.name, proc.purchase_id.name)
                 
-        end_date = datetime.now()
+        end_date = time.strftime('%Y-%m-%d %H:%M:%S')
                 
         summary = '''Here is the procurement scheduling report for Threshold values
 
@@ -95,12 +95,17 @@
         End Time: %s
         Total Procurements processed: %d
         Procurements with exceptions: %d
-        \n %s \n'''% (start_date, end_date, len(created_proc), report_except, len(created_proc) > 0 and created_doc or '')
+        \n %s \n  Exceptions: \n'''% (start_date, end_date, len(created_proc), report_except, len(created_proc) > 0 and created_doc or '')
         summary += '\n'.join(report)
+        if batch_id:
+            self.pool.get('procurement.batch.cron').write(cr, uid, batch_id, {'last_run_on': time.strftime('%Y-%m-%d %H:%M:%S')})
+            old_request = request_obj.search(cr, uid, [('batch_id', '=', batch_id), ('name', '=', 'Procurement Processing Report (Threshold values).')])
+            request_obj.write(cr, uid, old_request, {'batch_id': False})
         req_id = request_obj.create(cr, uid,
                 {'name': "Procurement Processing Report (Threshold values).",
                  'act_from': uid,
                  'act_to': uid,
+                 'batch_id': batch_id,
                  'body': summary,
                 })
         # UF-952 : Requests should be in consistent state

